package com.nisum.ecomservice.service;

import com.nisum.ecomservice.model.Product;
import com.nisum.ecomservice.model.Promotion;
import org.springframework.stereotype.Service;
import org.springframework.web.reactive.function.client.WebClient;
import reactor.core.publisher.Flux;

@Service
public class ProductService {

    public Flux<Product> getAllProducts() {
        return WebClient
                .builder()
                .baseUrl("http://localhost:8081")
                .build()
                .get()
                .uri("/api/products")
                .retrieve()
                .bodyToFlux(Product.class);
    }

    public Flux<Promotion> getAllPromotions() {
        return WebClient
                .builder()
                .baseUrl("http://localhost:8082")
                .build()
                .get()
                .uri("/api/promos")
                .retrieve()
                .bodyToFlux(Promotion.class);
    }

}
